-#!/bin/bash
+#!/usr/bin/env bash
# SPDX-License-Identifier: MIT
-set -x
-set -e
+set -o errexit
+set -o nounset
+set -o pipefail
+set -o xtrace
+
+cd "$(dirname "$0")"
unset LC_CTYPE
unset LANG
-build_m1n1()
-{
-(
- test -d m1n1 || git clone --recursive https://github.com/AsahiLinux/m1n1.git
- cd m1n1
- git fetch
- git reset --hard origin/main; git clean -f -x -d
- make -j 16
-)
-}
-
-build_uboot()
-{
-(
- # Build u-boot
- test -d u-boot || git clone --depth 1 https://github.com/jannau/u-boot -b x2r10g10b10
- cd u-boot
- git fetch
- git reset --hard origin/x2r10g10b10; git clean -f -x -d
- make apple_m1_defconfig
- make -j 16
-)
-
- cat m1n1/build/m1n1.bin `find linux/arch/arm64/boot/dts/apple/ -name \*.dtb` u-boot/u-boot-nodtb.bin > u-boot.bin
- cat m1n1/build/m1n1.macho `find linux/arch/arm64/boot/dts/apple/ -name \*.dtb` u-boot/u-boot-nodtb.bin > u-boot.macho
-}
-
-build_linux()
-{
-(
- test -d linux || git clone --depth 1 https://github.com/AsahiLinux/linux -b smc/work
- cd linux
- git fetch
- git reset --hard origin/smc/work; git clean -f -x -d
- curl -s https://tg.st/u/9ce9060dea91951a330feeeda3ad636bc88c642c.patch | git am -
- curl -s https://tg.st/u/5nly | git am -
- curl -s https://tg.st/u/0wM8 | git am -
- curl -s https://tg.st/u/m1-config-smc-2022-02-06 > .config
- curl -s https://tg.st/u/256f5efbf23ff68c489dad92f99d1cecfb021729.patch | git am -
- curl -s https://tg.st/u/8737955a0263d09ffa8550658dfcac1df3d0665c.patch | git am -
-
- make olddefconfig
- make -j 16 bindeb-pkg
-)
-}
+export DEBOOTSTRAP=debootstrap
build_rootfs()
{
(
sudo rm -rf testing
- sudo eatmydata debootstrap --arch=arm64 --include initramfs-tools,wpasupplicant,tcpdump,vim,tmux,vlan,ntpdate,bridge-utils,parted,curl,wget,grub-efi-arm64,mtr-tiny,dbus,ca-certificates,sudo,openssh-client testing testing http://ftp.fau.de/debian
-
- export KERNEL=`ls -1rt linux-image*.deb | grep -v dbg | tail -1`
+ mkdir -p cache
+ sudo eatmydata ${DEBOOTSTRAP} --cache-dir=`pwd`/cache --arch=arm64 --include initramfs-tools,pciutils,wpasupplicant,tcpdump,vim,tmux,vlan,ntpdate,parted,curl,wget,grub-efi-arm64,mtr-tiny,dbus,ca-certificates,sudo,openssh-client,mtools,gdisk,cryptsetup,wireless-regdb testing testing http://deb.debian.org/debian
cd testing
- sudo bash -c 'echo live > etc/hostname'
+ sudo mkdir -p boot/efi/m1n1 etc/X11/xorg.conf.d
+
+ sudo bash -c 'echo debian > etc/hostname'
sudo bash -c 'echo > etc/motd'
sudo cp ../../files/sources.list etc/apt/sources.list
+ sudo cp ../../files/glanzmann.list etc/apt/sources.list.d/
+ sudo cp ../../files/thomas-glanzmann.gpg etc/apt/trusted.gpg.d/
sudo cp ../../files/hosts etc/hosts
sudo cp ../../files/resolv.conf etc/resolv.conf
- sudo cp ../../files/fstab etc/fstab
sudo cp ../../files/quickstart.txt root/
sudo cp ../../files/interfaces etc/network/interfaces
sudo cp ../../files/wpa.conf etc/wpa_supplicant/wpa_supplicant.conf
+ sudo cp ../../files/rc.local etc/rc.local
+ sudo cp ../../files/30-modeset.conf etc/X11/xorg.conf.d/30-modeset.conf
+ sudo cp ../../files/blacklist.conf etc/modprobe.d/
+
+ sudo perl -p -i -e 's/"quiet"/"net.ifnames=0"/ if /^GRUB_CMDLINE_LINUX_DEFAULT=/' etc/default/grub
sudo bash -c 'chroot . apt update'
- sudo bash -c 'chroot . apt install -y firmware-linux-free'
+ sudo bash -c 'chroot . apt install -y firmware-linux'
sudo -- perl -p -i -e 's/root:x:/root::/' etc/passwd
sudo -- ln -s lib/systemd/systemd init
- sudo cp ../${KERNEL} .
- sudo chroot . dpkg -i ${KERNEL}
- sudo rm ${KERNEL}
-
- sudo bash -c 'apt-get clean'
+ sudo chroot . apt update
+ sudo chroot . apt install -y m1n1 linux-image-asahi
+ sudo chroot . apt clean
+ sudo rm var/lib/apt/lists/* || true
)
}
(
rm -rf live-stick
mkdir -p live-stick/efi/boot live-stick/efi/debian/
- sudo bash -c 'cd testing; find . | cpio --quiet -H newc -o | pigz > ../live-stick/initrd.gz'
+ sudo cp ../files/wifi.pl testing/etc/rc.local
+ sudo bash -c 'cd testing; find . | cpio --quiet -H newc -o | zstd -T0 -16 > ../live-stick/initrd.zstd'
cp testing/usr/lib/grub/arm64-efi/monolithic/grubaa64.efi live-stick/efi/boot/bootaa64.efi
cp testing/boot/vmlinuz* live-stick/vmlinuz
cp ../files/grub.cfg live-stick/efi/debian/grub.cfg
{
(
rm -f media
- dd if=/dev/zero of=media bs=1 count=0 seek=1G
+ dd if=/dev/zero of=media bs=1 count=0 seek=2G
mkdir -p mnt
mkfs.ext4 media
tune2fs -O extents,uninit_bg,dir_index -m 0 -c 0 -i 0 media
sudo mount -o loop media mnt
sudo cp -a testing/* mnt/
- sudo rm mnt/init
+ sudo rm -rf mnt/init mnt/boot/efi/m1n1
sudo umount mnt
- tar cf - media | pigz > m1.tgz
+ tar cf - media | pigz -9 > m1.tgz
)
}
-build_di_stick()
+build_efi()
{
- rm -rf di-stick
- mkdir -p di-stick/efi/boot di-stick/efi/debian/
- test -f initrd.gz || wget https://d-i.debian.org/daily-images/arm64/daily/netboot/debian-installer/arm64/initrd.gz
- sudo rm -rf initrd; mkdir initrd; (cd initrd; gzip -cd ../initrd.gz | sudo cpio -imd --quiet)
- sudo rm -rf initrd/lib/modules/*
- sudo cp -a testing/lib/modules/* initrd/lib/modules/
- sudo cp ../files/wpa.conf initrd/etc/
- (cd initrd; find . | cpio --quiet -H newc -o | pigz > ../di-stick/initrd.gz)
- sudo rm -rf initrd
- cp testing/usr/lib/grub/arm64-efi/monolithic/grubaa64.efi di-stick/efi/boot/bootaa64.efi
- cp testing/boot/vmlinuz* di-stick/vmlinuz
- cp ../files/grub.cfg di-stick/efi/debian/grub.cfg
- export KERNEL=`ls -1rt linux-image*.deb | grep -v dbg | tail -1`
- cp ${KERNEL} di-stick/
- (cd di-stick; tar cf ../m1-d-i.tar .)
+(
+ rm -rf EFI
+ mkdir -p EFI/boot EFI/debian
+ cp testing/usr/lib/grub/arm64-efi/monolithic/grubaa64.efi EFI/boot/bootaa64.efi
+
+ export INITRD=`ls -1 testing/boot/ | grep initrd`
+ export VMLINUZ=`ls -1 testing/boot/ | grep vmlinuz`
+ export UUID=`blkid -s UUID -o value media`
+ cat > EFI/debian/grub.cfg <<EOF
+search.fs_uuid ${UUID} root
+linux (\$root)/boot/${VMLINUZ} root=UUID=${UUID} rw net.ifnames=0
+initrd (\$root)/boot/${INITRD}
+boot
+EOF
+)
}
-upload()
+build_asahi_installer_image()
{
- unset MYCURLARGS;
- for FILE in "$@"; do
- MYCURLARGS="$MYCURLARGS -F file=@${FILE}";
- done;
- curl -n -D - $MYCURLARGS https://upload.glanzmann.de/ | grep ^x-location | awk '{print $2}'
+(
+ rm -rf aii
+ mkdir -p aii/esp/m1n1
+ cp -a EFI aii/esp/
+ cp testing/usr/lib/m1n1/boot.bin aii/esp/m1n1/boot.bin
+ ln media aii/media
+ cd aii
+ zip -r9 ../debian-base.zip esp media
+)
}
-
-upload_artefacts()
+publish_artefacts()
{
- export KERNEL=`ls -1rt linux-image*.deb | grep -v dbg | tail -1`
- cp ${KERNEL} k.deb
- upload m1-d-i.tar m1.tgz asahi-debian-live.tar u-boot.bin u-boot.macho di-stick/vmlinuz k.deb
+ echo upload build/asahi-debian-live.tar build/debian-base.zip
}
mkdir -p build
cd build
-build_linux
-build_m1n1
-build_uboot
+sudo apt-get install -y build-essential bash git locales gcc-aarch64-linux-gnu libc6-dev device-tree-compiler imagemagick ccache eatmydata debootstrap pigz libncurses-dev qemu-user-static binfmt-support rsync git flex bison bc kmod cpio libncurses5-dev libelf-dev:native libssl-dev dwarves zstd
+
build_rootfs
-build_live_stick
-build_di_stick
build_dd
-upload_artefacts
+build_efi
+build_asahi_installer_image
+build_live_stick
+publish_artefacts